轉載於http://justcoding.iteye.com/blog/1943504html
咱們在運維中,尤爲是linux運維,都知道腳本的重要性,腳本會讓咱們的 運維事半功倍,因此學會寫腳本是咱們每一個linux運維必須學會的一門功課,這裏收藏linux運維經常使用的腳本。如何學好腳本,最關鍵的是就是大量的練習 和實踐。根據如下腳本咱們能夠拓展,這樣咱們提升的很快!觸類旁通!mysql
1.用Shell編程,判斷一文件是否是字符設備文件,若是是將其拷貝到 /dev 目錄下。linux
參考程序:
C代碼 收藏代碼nginx
FILENAME=
echo 「Input file name:」
read FILENAME
if [ -c "$FILENAME" ]
then
cp $FILENAME /dev
fiweb
2.設計一個shell程序,添加一個新組爲class1,而後添加屬於這個組的30個用戶,用戶名的形式爲stdxx,其中xx從01到30。sql
參考答案:
C代碼 收藏代碼shell
i=1
groupadd class1
while [ $i -le 30 ]
do
if [ $i -le 9 ] ;then
USERNAME=stu0\({i} else USERNAME=stu\){i}
fi
useradd \(USERNAME mkdir /home/\)USERNAME
chown -R \(USERNAME /home/\)USERNAME
chgrp -R class1 /home/\(USERNAME i=\)(($i+1))
done編程
3.編寫shell程序,實現自動刪除50個帳號的功能。帳號名爲stud1至stud50。ubuntu
參考程序:
C代碼 收藏代碼vim
i=1
while [ $i -le 50 ]
do
userdel -r stud\({i} i=\)(($i+1 ))
done
4.某系統管理員需天天作必定的重複工做,請按照下列要求,編制一個解決方案:
(1)在下午4 :50刪除/abc目錄下的所有子目錄和所有文件;
(2)從早8:00~下午6:00每小時讀取/xyz目錄下x1文件中每行第一個域的所有數據加入到/backup目錄下的bak01.txt文件內;
(3)每逢星期一下午5:50將/data目錄下的全部目錄和文件歸檔並壓縮爲文件:backup.tar.gz;
(4)在下午5:55將IDE接口的CD-ROM卸載(假設:CD-ROM的設備名爲hdc);
(5)在早晨8:00前開機後啓動。
參考答案:
解決方案:
(1)用vi建立編輯一個名爲prgx的crontab文件;
(2)prgx文件的內容:
C代碼 收藏代碼
50 16 * * * rm -r /abc/*
0 8-18/1 * * * cut -f1 /xyz/x1 >;>; /backup/bak01.txt
50 17 * * * tar zcvf backup.tar.gz /data
55 17 * * * umount /dev/hdc
(3)由超級用戶登陸,用crontab執行 prgx文件中的內容:
root@xxx:#crontab prgx;在每日早晨8:00以前開機後便可自動啓動crontab。
5.設計一個shell程序,在每個月第一天備份並壓縮/etc目錄的全部內容,存放在/root/bak目錄裏,且文件名爲以下形式yymmdd_etc,yy爲年,mm爲月,dd爲日。Shell程序fileback存放在/usr/bin目錄下。
參考答案:
(1)編寫shell程序fileback:
C代碼 收藏代碼
DIRNAME=ls /root | grep bak
if [ -z "$DIRNAME" ] ; then
mkdir /root/bak
cd /root/bak
fi
YY=date +%y
MM=date +%m
DD=date +%d
BACKETC=\(YY\)MM$DD_etc.tar.gz
tar zcvf $BACKETC /etc
echo 「fileback finished!」
(2)編寫任務定時器:
C代碼 收藏代碼
echo 「0 0 1 * * /bin/sh /usr/bin/fileback」 >; /root/etcbakcron
crontab /root/etcbakcron
或使用crontab -e 命令添加定時任務:
0 1 * * * /bin/sh /usr/bin/fileback
6.有一普通用戶想在每週日凌晨零點零分按期備份/user/backup到/tmp目錄下,該用戶應如何作?
參考答案:
(1)第一種方法:
C代碼 收藏代碼
用戶應使用crontab –e 命令建立crontab文件。格式以下:
0 0 * * sun cp –r /user/backup /tmp
(2)第二種方法:
用戶先在本身目錄下新建文件file,文件內容以下:
C代碼 收藏代碼
0 * * sun cp –r /user/backup /tmp
而後執行 crontab file 使生效。
7.設計一個Shell程序,在/userdata目錄下創建50個目錄,即user1~user50,並設置每一個目錄的權限,其中其餘用戶的權限爲:讀;文件全部者的權限爲:讀、寫、執行;文件全部者所在組的權限爲:讀、執行。
參考答案: 創建程序 Pro16以下:
C代碼 收藏代碼
i=1
while [ i -le 50 ]
do
if [ -d /userdata ];then
mkdir -p /userdata/user\(i chmod 754 /userdata/user\)i
echo 「user\(i」 let 「i = i + 1″ (或i=\)((\(i+1)) else mkdir /userdata mkdir -p /userdata/user\)i
chmod 754 /userdata/user\(i echo 「user\)i」
let 「i = i + 1″ (或i=\(((\)i+1))
fi
done
八、mysql備份實例,自動備份mysql,並刪除30天前的備份文件
C代碼 收藏代碼
BAKDIR=/data/backup/mysql/date +%Y-%m-%d
MYSQLDB=www
MYSQLPW=backup
MYSQLUSR=backup
if[ $UID -ne 0 ];then
echo This script must use administrator or root user ,please exit!
sleep 2
exit 0
fi
if[ ! -d $BAKDIR ];then
mkdir -p $BAKDIR
else
echo This is $BAKDIR exists ,please exit ….
sleep 2
exit
fi
/usr/bin/mysqldump -u\(MYSQLUSR -p\)MYSQLPW -d $MYSQLDB >/data/backup/mysql/date +%Y-%m-%d
/www_db.sql
cd $BAKDIR ; tar -czf www_mysql_db.tar.gz *.sql
cd $BAKDIR ;find . -name 「*.sql」 |xargs rm -rf[ $? -eq 0 ]&&echo 「This date +%Y-%m-%d
RESIN BACKUP is SUCCESS」
cd /data/backup/mysql/ ;find . -mtime +30 |xargs rm -rf
九、自動安裝Nginx腳本,採用case方式,選擇方式,也能夠根據實際需求改爲本身想要的腳本
C代碼 收藏代碼
SOFT_PATH=/data/soft/
NGINX_FILE=nginx-1.2.0.tar.gz
DOWN_PATH=http://nginx.org/download/
if[ $UID -ne 0 ];then
echo This script must use administrator or root user ,please exit!
sleep 2
exit 0
fi
if[ ! -d $SOFT_PATH ];then
mkdir -p $SOFT_PATH
fi
download ()
{
cd $SOFT_PATH ;wget \(DOWN_PATH/\)NGINX_FILE
}
install ()
{
yum install pcre-devel -y
cd $SOFT_PATH ;tar xzf $NGINX_FILE ;cd nginx-1.2.0/ &&./configure –prefix=/usr/local/nginx/ –with-http_stub_status_module –with-http_ssl_module
[ $? -eq 0 ]&&make &&make install
}
start ()
{
lsof -i :80[ $? -ne 0 ]&&/usr/local/nginx/sbin/nginx
}
stop ()
{
ps -ef |grep nginx |grep -v grep |awk ‘{print $2}’|xargs kill -9
}
exit ()
{
echo $? ;exit
}
case $1 in
download )
download
;;
install )
install
;;
start )
start
;;
stop )
stop
;;
echo 「USAGE:$0 {download or install or start or stop}」
exit
esac
十、批量解壓tar腳本,批量解壓zip而且創建當前目錄。
C代碼 收藏代碼
PATH1=/tmp/images
PATH2=/usr/www/images
for i in ls ${PATH1}/*
do
tar xvf $i -C $PATH2
done
這個腳本是針對全部tar文件在一個目錄,可是實際狀況中,有可能在下級或者更深的目錄,咱們可使用find查找
C代碼 收藏代碼
PATH1=/tmp/images
PATH2=/usr/www/images
for i in find $PATH1 -name 」*.tar」
do
tar xvf $i -C $PATH2
done
如何是zip文件,例如123189.zip 132342.zip 等等批量文件,默認unzip直接解壓不帶自身目錄,意思是解壓123189.zip完當前目錄就是圖片,不能建立123189目錄下並解壓,能夠用shell腳本實現
C代碼 收藏代碼
PATH1=/tmp/images
PATH2=/usr/www/images
cd $PATH1
for i in find . -name 」*.zip」|awk -F. {print $2}
do
mkdir -p PATH2$i
unzip -o .\(i.zip -d PATH2\)i
done
原創文章轉載請註明: Linux經常使用Shell腳本珍藏 | 專一Unix/Linux領域
ssh 批量上傳文件
上傳文件大多數用的是ftp,可是用ftp有一點很差,就是本地和遠程的目錄要對應,這樣就要在多個目錄下去切換,這樣挺麻煩的,若是不注意的話,頗有可能傳錯。因此想了個辦法利用scp來批量上傳文件或者目錄。
一,scp上傳不要輸入密碼
若是要用scp來上傳文件,第一步就要去掉scp上傳時要輸入密碼。要否則就沒辦法批量上傳了。具體請參考:ssh 不用輸入密碼
二,ssh批量上傳腳本
1,要上傳的文件列表放到一個test文件中
C代碼 收藏代碼
root@ubuntu:/home/zhangy# cat test
/home/zhangy/test/aaa
/home/zhangy/test/nginx.conf
/home/zhangy/test/test.sql
/home/zhangy/test/pa.txt
/home/zhangy/test/password
上面就要上傳的文件。
2,批量上傳的腳本
vim file_upload.sh
C代碼 收藏代碼
DATE=date +%Y_%m_%d_%H
if [ $1 ]
then
for file in \((sed '/^\)/d' $1) //去掉空行
do
if [ -f $file ] //普通文件
then
res=scp $file $2:$file
//上傳文件
if [ -z $res ] //上傳成功
then
echo $file >> ${DATE}_upload.log //上傳成功的日誌
fi
elif [ -d $file ] //目錄
then
res=scp -r $file $2:$file
if [ -z $res ]
then
echo $file >> ${DATE}_upload.log
fi
fi
done
else
echo "no file" >> ${DATE}_error.log
fi
上傳成功後,返回的是一個空行,上傳不成功,什麼都不返回
3,上傳的格式
C代碼 收藏代碼
./file_upload.sh test 192.168.1.13
test是上傳列表文件,192.168.1.13文件要傳到的地方。
0
轉載請註明
做者:海底蒼鷹
地址:http://blog.51yip.com/linux/1356.html
C代碼 收藏代碼
# lowerit
for x in ls
do
if [ ! -f $x ]; then
continue
fi
lc=echo $x | tr '[A-Z]' '[a-z]'
if [ $lc != $x ]; then
mv -i $x $lc
fi
done
or
C代碼 收藏代碼
if test $# = 0
then
echo "Usage $0:
exit 1
fi
for filename in "\(@" do new_filename=`echo "\)filename" | tr A-Z a-z`
test "\(filename" = "\)new_filename" && continue
if test -r "$new_filename"
then
echo "$0: \(new_filename exists" 1>&2 elif test -e "\)filename"
then
mv "\(filename" "\)new_filename"
else
echo "$0: $filename not found" 1>&2
fi
done
A script to repeated download a webpage until it matches a regex then notify an e-mail address.
For example to get e-mail when Kesha tickets (not for yourself of course) go on sale you might run:
C代碼 收藏代碼
% watch_website.sh http://ticketek.com.au/ 'Ke[sS$]+ha' andrewt@cse.unsw.edu.au
repeat_seconds=300 #check every 5 minutes
if test $# = 3
then
url=$1
regexp=$2
email_address=$3
else
echo "Usage: $0
exit 1
fi
while true
do
if wget -O- -q "\(url"|egrep "\)regexp" >/dev/null
then
echo "Generated by \(0" | mail -s "\)url now matches $regexp" $email_address
exit 0
fi
sleep $repeat_seconds
done
This scripts converts GIF files to PNG files via the intermediate PPM format.
C代碼 收藏代碼
if [ $# -eq 0 ]
then
echo "Usage: $0 files..." 1>&2
exit 1
fi
if ! type giftopnm 2>/dev/null
then
echo "$0: conversion tool giftopnm not found " 1>&2
exit 1
fi
*.gif) # OK, do nothing ;; *) echo "gif2png: skipping $f, not GIF" continue ;; esac dir=`dirname "$f"` base=`basename "$f" .gif` result="$dir/$base.png" giftopnm "$f" | pnmtopng > $result && echo "wrote $result"
done
A utility script to print the sub-range of integers specified by its arguments.
Useful to use on the command line or from other scripts
C代碼 收藏代碼
if test $# = 1
then
start=1
finish=$1
elif test $# = 2
then
start=$1
finish=$2
else
echo "Usage: $0
exit 1
fi
for argument in "\(@" do if echo "\)argument"|egrep -v '^-?[0-9]+$' >/dev/null
then
echo "\(0: argument '\)argument' is not an integer" 1>&2
exit 1
fi
done
number=$start
while test $number -le $finish
do
echo $number
number=expr $number + 1
# or number=\(((\)number + 1))
done
C代碼 收藏代碼
sed 's/ /\n/g' "\(@"| # convert to one word per line tr A-Z a-z| # map uppercase to lower case sed "s/[^a-z']//g"| # remove all characters except a-z and ' egrep -v '^\)'| # remove empty lines
sort| # place words in alphabetical order
uniq -c| # use uniq to count how many times each word occurs
sort -n # order words in frequency of occurrance
For example
C代碼 收藏代碼
% cd /home/cs2041/public_html/lec/shell/examples
% ./word_frequency.sh dracula.txt|tail
2124 it
2440 that
2486 in
2549 he
2911 a
3600 of
4448 to
4740 i
5833 and
7843 the
Search $PATH for the specified programs
C代碼 收藏代碼
if test $# = 0
then
echo "Usage $0:
exit 1
fi
for program in "\(@" do program_found='' for directory in `echo "\)PATH" | tr ':' ' '`
do
f="\(directory/\)program"
if test -x "\(f" then ls -ld "\)f"
program_found=1
fi
done
if test -z \(program_found then echo "\)program not found"
fi
done
Alternative implementation using while, and a cute use of grep and ||
C代碼 收藏代碼
if test $# = 0
then
echo "Usage $0:
exit 1
fi
for program in "\(@" do echo "\)PATH"|
tr ':' '\n'|
while read directory
do
f="\(directory/\)program"
if test -x "\(f" then ls -ld "\)f"
fi
done|
egrep '.' || echo "$program not found"
done
And another implementation using while, and a cute use of grep and ||
C代碼 收藏代碼
if test $# = 0
then
echo "Usage \(0: <program>" 1>&2 exit 1 fi for program in "\)@"
do
n_path_components=echo $PATH|tr -d -c :|wc -c
index=1
while test $index -le \(n_path_components do directory=`echo "\)PATH"|cut -d: -f\(index` f="\)directory/\(program" if test -x "\)f"
then
ls -ld "$f"
program_found=1
fi
index=expr $index + 1
done
test -n \(program_found || echo "\)program not found"
done
來源: http://www.cse.unsw.edu.au/~cs2041/12s2/lec/shell/examples.notes.html